﻿#BUFFER_SIZE=16384;/* must be > MAX_OFFSET */

Global output_index

Global *input_data=AllocateMemory(#BUFFER_SIZE)
Global *output_data=AllocateMemory(#BUFFER_SIZE)
Global input_index
Global input_size
Global output_size
Global partial_counter
Global bit_mask.a
Global bit_value.a

Procedure.a read_byte()
    If input_index = partial_counter
        input_index = 0;
        partial_counter = ?te-?tt
        input_size +partial_counter;
        If partial_counter = 0
            Debug "empty file"
            End
        EndIf
      EndIf
      rb.a=PeekA(*input_data+input_index)
      input_index+1
    ProcedureReturn rb
EndProcedure

Procedure.a read_bit()
    bit_mask >>1;
    If bit_mask = 0
        bit_mask = 128;
        bit_value = read_byte();
      EndIf
      If bit_value & bit_mask
        bv=1
      Else
        bv=0
      EndIf
    ProcedureReturn bv
EndProcedure

Procedure.l read_elias_gamma()
    i = 0;
    While Not read_bit()
        i+1
    Wend
    If i > 15
        ProcedureReturn -1
    EndIf
    value.b = 1;
    While i
      i-1
        value = value << 1 | read_bit();
    Wend
    ProcedureReturn value;
EndProcedure

Procedure read_offset()
    value = read_byte();
    If value < 128
        ProcedureReturn value
    Else
        i = read_bit();
        i = i << 1 | read_bit();
        i = i << 1 | read_bit();
        i = i << 1 | read_bit();
        ProcedureReturn  (value & 127 | i << 7) + 128;
    EndIf
EndProcedure

Procedure write_byte(value.a)
  PokeA(*output_data+output_index,value)
  output_index+1
    If output_index = #BUFFER_SIZE
        Debug "save_output()"
    EndIf
EndProcedure

Procedure write_bytes(offset, length)
    If offset > output_size+output_index
      Debug "invalid data"
      End
    EndIf
    While length > 0
      length-1
        i = output_index-offset;
        If i>=0
          ii=i
        Else
          ii=#BUFFER_SIZE+i
        EndIf
        write_byte(PeekA(*output_data+ii))
    Wend
EndProcedure


Procedure decompress()
    input_size = 0;
    input_index = 0;
    partial_counter = 0;
    output_index = 0;
    output_size = 0;
    bit_mask = 0;

    write_byte(read_byte());
    While 1
        If (Not read_bit())
            write_byte(read_byte());
        Else
            length = read_elias_gamma()+1;
            If length = 0
              Debug "write "+Str(output_index)
              CreateFile(0,"cha.txt")
              WriteData(0,*output_data,output_index)
             CloseFile(0)
                If input_index <> partial_counter
                  Debug "Error: Input file %s too long"
                  End
                EndIf
                ProcedureReturn
            EndIf
            write_bytes(read_offset()+1, length);
        EndIf
    Wend
EndProcedure


forced_mode = 1

CopyMemory(?tt,*input_data,?te-?tt)
decompress()

FreeMemory(*input_data)
FreeMemory(*output_data)
DataSection
  tt:
  IncludeBinary "chastushki.txt.zx7"
  te:
; IDE Options = PureBasic 5.30 (Windows - x86)
; Folding = --
; EnableXP